﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BaileyTicTacToe
{
    class ComputerPlayer : Player
    {
        public ComputerPlayer()
        {
        }

        public override int MakeMove(Board gameBoard, int position, HumanPlayer playerX)
        {
            int winningCombos;
            int winningCombos2;
            int winningCombos3;

            for (int i = 0; i < gameBoard.WinningCombos.GetLength(0); i++)
            {
                winningCombos = gameBoard.WinningCombos[i, 0];
                winningCombos2 = gameBoard.WinningCombos[i, 1];
                winningCombos3 = gameBoard.WinningCombos[i, 2];

                if ((!base.Pieces[winningCombos] ? false : base.Pieces[winningCombos2]))
                {
                    position = winningCombos3;
                }
                else if ((!base.Pieces[winningCombos2] ? false : base.Pieces[winningCombos3]))
                {
                    position = winningCombos;
                }
                else if ((!base.Pieces[winningCombos] ? false : base.Pieces[winningCombos3]))
                {
                    position = winningCombos2;
                }
                if ((position < 0 ? true : !gameBoard.OpenPositions.Contains(position)))
                {
                    position = -1;
                }
                else
                {
                    i = gameBoard.WinningCombos.GetLength(0);
                }
            }

            if (position < 0)
            {
                for (int j = 0; j < gameBoard.WinningCombos.GetLength(0); j++)
                {
                    winningCombos = gameBoard.WinningCombos[j, 0];
                    winningCombos2 = gameBoard.WinningCombos[j, 1];
                    winningCombos3 = gameBoard.WinningCombos[j, 2];

                    if ((!playerX.Pieces[winningCombos] ? false : playerX.Pieces[winningCombos2]))
                    {
                        position = winningCombos3;
                    }
                    else if ((!playerX.Pieces[winningCombos2] ? false : playerX.Pieces[winningCombos3]))
                    {
                        position = winningCombos;
                    }
                    else if ((!playerX.Pieces[winningCombos] ? false : playerX.Pieces[winningCombos3]))
                    {
                        position = winningCombos2;
                    }
                    if ((position < 0 ? true : !gameBoard.OpenPositions.Contains(position)))
                    {
                        position = -1;
                    }
                    else
                    {
                        j = gameBoard.WinningCombos.GetLength(0);
                    }
                }
            }

            if (position < 0)
            {
                position = (int)gameBoard.OpenPositions[0];
            }

            gameBoard.OpenPositions.Remove(position);
            base.Pieces[position] = true;
            return position;
        }
    }
}
